#pragma once

#include <base/signal.h>
#include <dataspace/capability.h>
#include <session/session.h>
#include <irq_session/capability.h>

namespace Counter { struct Session; }


struct Counter::Session : Genode::Session
{
	/**
	 * \noapi
	 */
	static const char *service_name() { return "Counter"; }

	enum { CAP_QUOTA = 2 };

	virtual ~Session() { }

	virtual void increment() = 0;

	virtual Genode::uint64_t get() const = 0;

	/*******************
	 ** RPC interface **
	 *******************/

	GENODE_RPC(Rpc_increment,   void, increment);
	GENODE_RPC(Rpc_get,         Genode::uint64_t, get);

	GENODE_RPC_INTERFACE(Rpc_increment, Rpc_get);
};

